USE m3console;
-- BACKUPS
CREATE TABLE IF NOT EXISTS tmp_item_catalog_0201 AS SELECT * FROM `tbl_item_catalog`;
CREATE TABLE IF NOT EXISTS tmp_clinic_catalog_0201 AS SELECT * FROM `tbl_clinic_catalog`;
CREATE TABLE IF NOT EXISTS tmp_vendor_list_0201 AS SELECT * FROM `tbl_vendor_list`;


RENAME TABLE `tbl_vendor_list` to `tbl_catalogs`;
ALTER TABLE `tbl_catalogs` CHANGE `vendor_id` `catalog_id` VARCHAR(255) NOT NULL COLLATE 'utf8_general_ci';
ALTER TABLE `tbl_catalogs` CHANGE `vendor_display` `catalog_display` VARCHAR(255) NOT NULL COLLATE 'utf8_general_ci';

ALTER TABLE `tbl_item_catalog` CHANGE `vendor_id` `catalog_id` INT(11) NOT NULL;
ALTER TABLE `tbl_clinic_catalog` CHANGE `vendor_id` `catalog_id` INT(11) NOT NULL;


CREATE TABLE `tbl_vendor_list` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `vendor_id` VARCHAR(255) NOT NULL COLLATE 'utf8_general_ci',
  `vendor_display` VARCHAR(255) NOT NULL COLLATE 'utf8_general_ci',
  `minimum_order_amount` DECIMAL(9,2) DEFAULT 0.00,
  `fee` DECIMAL(9,2) DEFAULT 0.00,
  `date_modified` TIMESTAMP(3) NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
)
  COLLATE='latin1_swedish_ci'
  ENGINE=InnoDB
  AUTO_INCREMENT=1
;

INSERT INTO `tbl_vendor_list` (vendor_id, vendor_display) SELECT catalog_id, catalog_display FROM `tbl_catalogs` WHERE is_med_group = 1;

/*
CREATE PROCEDURE prc_convert_catalog_ids()
  BEGIN
    DECLARE done INT DEFAULT FALSE;
    DECLARE vendor_cursor CURSOR FOR SELECT id, vendor_id FROM tbl_vendor_list;
    DECLARE vendor_id VARCHAR(255) COLLATE 'utf8_general_ci';
    DECLARE vid INT(11);
    DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;

    OPEN vendor_cursor;

    read_loop: LOOP
      FETCH vendor_cursor INTO vid, vendor_id;
      IF done THEN
        LEAVE read_loop;
      END IF;
      UPDATE `tbl_catalogs` SET id = vid WHERE catalog_id = vendor_id;
    END LOOP;

    CLOSE vendor_cursor;

  END;

CALL prc_convert_catalog_ids();


ALTER TABLE `tbl_item_catalog` DROP FOREIGN KEY `FK_Item_catalog_Vendor`;
ALTER TABLE `tbl_item_catalog` ADD CONSTRAINT `FK_Item_catalog_Vendor` FOREIGN KEY (`catalog_id`) REFERENCES `tbl_catalogs` (`id`) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE `tbl_clinic_catalog` DROP FOREIGN KEY `FK_Clinic_catalog_Vendor`;
ALTER TABLE `tbl_clinic_catalog` ADD CONSTRAINT `FK_Clinic_catalog_Vendor` FOREIGN KEY (`catalog_id`) REFERENCES `tbl_catalogs` (`id`) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE `tbl_vendor_list` DROP COLUMN is_med_group;
ALTER TABLE `tbl_vendor_list` ADD (minimum_order_amount DECIMAL(9,2) DEFAULT 0.00);
 */

ALTER TABLE `tbl_master_item` ADD (vendor_id VARCHAR(255) COLLATE 'utf8_general_ci');
ALTER TABLE `tbl_master_item` ADD (unit_price DECIMAL(9,2) DEFAULT 0.00);

DELETE FROM `tbl_catalogs` WHERE is_med_group = 1;
ALTER TABLE `tbl_catalogs` DROP COLUMN is_med_group;

